' BandEdgePlot.bas for FilmStar DESIGN/MEASURE
' Copyright 2004-2012 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Test for band edge calculations
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Band Edge Plot
'   Command       basrun c:\winfilm\basic32\bandedgeplot.bas;


Option Explicit
Option Base 1
DefInt I-N
DefSng A-H, O-Z

Sub Main
    Dim wEdge, yEdge, wMin, wMax, Level, s$
    Dim kErr As Boolean
    Calculate  ' Replace with Scan when used with MEASURE
    AxesRange wMin, wMax	' get limits from current graph range
    Level = 50              ' initial value
	Do
        Level = Val(InputBox("Enter cuton/cutoff level in %", "Edge Filter Calc", CStr(Level)))
        If Level = 0 Then
            Busy False
            End
        End If
        PlotClose
        EdgeCalc Level, wMin, wMax, wEdge, yEdge, kErr
        PlotAnnotate True
        s$ = PlotAnnotation   ' any permanent annotation saved with Graph Axes or Scan Method?
        If s$ = "" Then s$ = "VERS3" & vbCrLf
        PlotAnnotation = s$ & "vline " & CStr(wEdge) & ",9,|b " & Format$(wEdge, "0.0#") & " nm,16711680;0" _
          & vbCrLf & "hline " & CStr(100*yEdge) & ",9,|l" & CStr(Level) & "% Level,16711680;0"
        PlotActivate
        PlotNext
        PlotAnnotation = s$  ' restores permanent annotation after plotting
    Loop
End Sub

Sub AxesRange(wMin, wMax)
    Dim k, s$
    AxesCopy
    s$ = Clipboard$()
    k = InStr(s$, vbTab)
    wMin = Val(Mid$(s$, 1, k -1))
    s$ = Mid$(s$, k + 1)
    k = InStr(s$, vbTab)
    wMax = Val(Mid$(s$, 1, k -1))
End Sub
