' BandWidthPlot.bas for FilmStar DESIGN, MEASURE
' Copyright 1995-2010 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Plots graph showing max, center and half width
' Based on BandWidth.bas
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   BandPass Filter
'   Command       basrun c:\winfilm\basic\bandwidthplot.bas;
'
Option Explicit
DefInt I-N
DefSng A-H, O-Z

Sub Main
    Dim k, kErr As Boolean, b50, tm, wc, wMin, wMax, gs$, wu$
    Busy True
    ' Calculate within range wMin, wMax as shown in FilmStar DESIGN, MEASURE screen
    ' This allows the spectral data set to be larger than the displayed axes
    ' when there are several peaks to be considered

    ' *****************************************
    '      Included for new users
    '      Change or delete as required
     FileOpen "Fnum.faw"
    ' *****************************************
    GraphSetup

    ' NMEACGT:  N nm  M m  E cm  A ngs  C 1/cm  G GHz  T Thz
    Select Case WaveUnit
    Case "N"
        wu$ = " nm"
    Case "M"
        wu$ = " m"
    Case "A"
        wu$ = " ngs"
    Case "C"
        wu$ = " 1/cm"
    End Select
       
    ' *****************************************
    '      Change to Scan if using MEASURE
    Calculate
    ' *****************************************

    AxesRange wMin, wMax   ' get range from current graph axes
    BandMax wMin, wMax, tm, kErr
    tm = 100*tm
    If Not kErr Then BandCtr wMin, wMax, wc, kErr
    If Not kErr Then BandWidth 50, wMin, wMax, b50, kErr
    If Not kErr Then
        PlotClose
        gs$ = "vline " & tStr(wc) & ",5,|b  " & eFmt$(wc) & wu$ & ",9;0" & vbCrLf
        gs$ = gs$ & "hline " & tStr(tm) & ",5,|l" & Replace(Format$(tm, "0.00"),",","`") & "%,9;0" & vbCrLf
        tm = tm/2
        gs$ = gs$ & "graph " & tStr(wc-b50/2) & "," & tStr(tm) & ",43,,9;0" & vbCrLf
        gs$ = gs$ & "graph " & tStr(wc+b50/2) & "," & tStr(tm) & ",45,,9;1" & vbCrLf
        ' offset label + 1%, -.7 %
        If wMax > wMin Then
            gs$ = gs$ & "graph " & tStr(wc + b50/2 + .01*(wMax-wMin)) & "," & tStr(tm-.7) & ",0," & eFmt$(b50) & wu$ & ",9;2"
        Else
            gs$ = gs$ & "graph " & tStr(wc - b50/2 + .01*(wMax-wMin)) & "," & tStr(tm-.7) & ",0," & eFmt$(b50) & wu$ & ",9;2"
        End If
        PlotAnnotation = gs$
        PlotAnnotate True   ' must be before PlotActivate
        PlotActivate
        PlotNext
    Else
        Display "----Error----", "Bandwidth Calculation", 6000, 4000, "Arial", 32, 1
    End If
    Busy False
End Sub

Sub AxesRange(wMin, wMax) ' works in DESIGN and MEASURE
    Dim k, s$
    k = Macro("AxesCopy;")
    s$ = Clipboard$()
    k = InStr(s$, vbTab)
    wMin = Val(Mid$(s$, 1, k -1))
    s$ = Mid$(s$, k + 1)
    k = InStr(s$, vbTab)
    wMax = Val(Mid$(s$, 1, k -1))
End Sub

Function tStr(ByVal v!) As String
    Select Case WaveUnit
    Case "M"
        tStr = Trim$(Str(Round(v,6)))
    Case Else
        tStr = Trim$(Str(Round(v,3)))
    End Select
End Function

Function eFmt$(v)
    ' Formats for European decimal (replace "," by "`")
    ' "`" is then replaced by "," in the FSPlot Module
    Select Case WaveUnit
    Case "M"
        eFmt$ = Replace(Format$(v, "0.0000"),",","`")
    Case Else
        eFmt$ = Replace(Format$(v, "0.00"),",","`")
    End Select
End Function

Sub GraphSetup
   ' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 8467665, 2129, 0
    PlotSize 9500, 8250, 90
    PlotTitleFont = "Arial"
    PlotTitleSize = 120
    PlotLegendSize = 100
    PlotAxesFont = "Arial"
    PlotAxesLabelSize = 100
    PlotAxesNumberSize = 100
    PlotFontFixed = False
    PlotFontFixedSize = 1
    PlotAxesConfig = 0
    PlotEdgeSpace 50, -25, 50, 25
    PlotAxesSpace .15, .3, .3, 1.5
    PlotColors "255, 16711680, 57088, 16711935, 8421376, 32896, 0, 8421504, 128, 8388608, 32768, 8388736"
    PlotBitmapMode = False
End Sub
