'#Reference {00020813-0000-0000-C000-000000000046}#1.9#0#C:\Program Files (x86)\Microsoft Office\root\Office16\EXCEL.EXE#Excel
' CdgmGlass.bas for FilmStar INDEX
' Copyright 2009-2020 FTG Software Associates
' Revised 05/20/2020
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Generates index tables from https://ftgsoftware.com/files/CdgmGlass.xlsm
'
' n generated from Sellmeier dispersion formula (SELLG2)
' k calculated from internal transmittance values
'
' Following settings recommended for AutoAxes:
'    Setup Parameters: Table type = Index
'          Graph Axes: k-Scale = Log
'
Option Explicit
Dim xlApp As Excel.Application
Dim xlBook As Excel.Workbook
Dim xlSheet As Excel.Worksheet

Sub Main
    Dim s$, p$, f$
    f$ = InputBox("Enter CDGM glass type", "INDEX")
    If Trim$(f$) <> "" Then
        OpenXlsFile PgmPath$ & "\CdgmGlass.xlsm"
        p$ = xlSheet.Range("dPath")
        If Not FileExists(p$ & f$ & ".xlsx") Then
            MsgBox "File " & p$ & f$ & ".xlsx not found", vbCritical, "CdgmGlass.bas"
            GoTo MainQuit
        End If
        xlSheet.Range("nType") = f$
        xlApp.Run "CreateExportTable"
        DoEvents
        IndexPaste
        AutoAxes True
        If MsgBox("Save Index Table 'CDGM " & f$ & ".itw'?", vbQuestion + vbYesNo, _
        "CDGM Glass") = vbYes Then FileSave "CDGM " & f$
    End If
MainQuit:
    On Error Resume Next
    xlApp.Quit
    Set xlSheet = Nothing
    Set xlBook = Nothing
    Set xlApp = Nothing
End Sub

Sub OpenXlsFile(ByVal f$)
	' If you get an error in the next line, you need to re-establish
    ' a reference to the Microsoft Excel Object Library
    Set xlApp = New Excel.Application
    Set xlBook = xlApp.Workbooks.Open(f$)
    Set xlSheet = xlBook.Sheets("Export")
    xlApp.DisplayAlerts = False	' no save prompt upon exiting Excel
End Sub

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFileFound
    If Trim$(f$) = "" Then
        FileExists = False
    Else
        FileExists = (FileLen(f$) > 0)
    End If
    Exit Function
NoFileFound:
    FileExists = False
    Exit Function
End Function
