' Program CIERandom.bas for FilmStar DESIGN
' Copyright 2010 FTG Software Associates
'
' Creates Excel-compatible CSV file including CIE
' x,y,Y values simulating layer errors
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
DefInt i-N
DefSng A-H, O-Z

' ****************************************************
' NOTE: This macro requires that the evaluation range
' include 380-780 x5 or x1 nm. Adjust in Graph Axes.
'
'              Change as required
Const Iter = 500
Const Path$ = "C:\Winfilm\CieRandom"
' ****************************************************

Option Explicit

Sub Main
    Dim i, f$, file$, x, y, yy
    Const t$ = "CIE Random"
    Calculate
    GetCieData x, y, yy  ' check CIE calculation range before looping!!
    If x = 0! And y = 0! Then End
    On Error GoTo CIERandErr
    Do
        file$ = InputBox("Enter file name without path or extension", t$)
        If Len(file$) = 0 Then End     ' no file name entered, so quit
        f$ = Path$ & "\" & file$ & ".csv"
        If FileExists(f$) Then
            If MsgBox("File already exists, overwrite it?", vbYesNo + vbDefaultButton2, t$) = vbYes Then
                Kill f$
                Exit Do
            End If
        Else
            Exit Do
        End If
    Loop
    Open f$ For Output As #1
    For i = 1 To Iter
        CalcRand
        GetCieData x, y, yy
        Print #1, Format$(x, "0.0000") & "," & Format$(y, "0.0000") & "," & Format$(yy, "0.00")
    Next i
    Close #1
    Exit Sub
CIERandErr:
    If Err.Number = 10051 Then
        MsgBox "Illegal file name, or path " & Path$ & " does not exist", vbCritical, t$
    Else
        MsgBox Err.Description, vbCritical, t$
    End If
    Exit Sub
End Sub

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFile
    FileExists = FileLen(f$) > 0
    Exit Function
NoFile:
    FileExists = False
End Function
