' CrystalList.bas for FilmStar DESIGN
' Copyright 1995-2010 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a list of thicknesses for crystal controllers
'
' 1. Add more tooling factors as required.
' 2. Enter material names under 'Description' in the Film Indices dialog
'
Option Explicit
DefInt i-n
DefSng a-h, o-z
Dim Tanks$(0 To 2)  ' 3 coating chambers

Sub Main
    Dim dname$, file$, iTank, ok As Boolean
    Dim ToolH, ToolL, ToolM
    Dim i, nl, q(), qt$(), qd$(), d$

    Tanks(0) = "Eddy Company 36 in"
    Tanks(1) = "Balzers BAP-760"
    Tanks(2) = "Sherman"

    dname$ = IniString("Files", "Path2")
    file$ = GetFilePath$(,"faw", dname$, "Open FILM Archive", 0)
    If file$ <> "" Then
        If FileOpen(file$) Then
            On Error GoTo MainBye   ' cancel pressed
            Begin Dialog UserDialog 320,153,"Select coating chamber" ' %GRID:5,3,1,1
                ListBox 30,18,265,66,Tanks(),.lstTank
                OKButton 45,120,80,21
                CancelButton 185,120,85,21
            End Dialog
            Dim dlg As UserDialog
            Dialog dlg
            iTank = dlg.lstTank
            Select Case iTank
            Case 0  ' Eddy
                ToolH = .65
                ToolL = .75
                ToolM = .64
            Case 1  ' Balzers
                ToolH = 1.3
                ToolL = 1.2
                ToolM = 1.1
            Case 2  ' Sherman
                ToolH = 1
                ToolL = 1
                ToolM = 1
            End Select
            Macro "DesignMult H " & CStr(ToolH) & ";"
            Macro "DesignMult L " & CStr(ToolL) & ";"
            Macro "DesignMult M " & CStr(ToolM) & ";Busy 0;"
            DesignConvert 1, "K"            ' convert to k
            GetLayers nl, q(), qt(), qd()   ' get design
            d$ = "FILM Archive " & GetName(file$) & vbCrLf & vbCrLf
            For i = 1 To nl
                d$ = d$ & Format$(i, "00") & "  " & Format$(q(i), "0.000") & " k  " & qd(i) & vbCrLf
            Next i
            Display d$, "Monitor settings for " & Tanks(iTank), 5000, 4500, "Arial", 10, 1

            FileOpen file$  ' restore original FILM Archive
        End If
    End If
MainBye:
    End
End Sub

Function GetName(ByVal f As String) As String
    ' Returns name used in dialog captions
    Dim k, fname As String, r As String
    k = InStr(f, "\")
    r = StrReverse$(f)
    k = Len(f) - InStr(r, "\") + 1
    r = Mid$(f$, k + 1)
    GetName = Left(r, Len(r)-4)
End Function

