' DescToName.bas For FilmStar Design 32 bit
' Copyright 2002 FTG Software Associates

' This program creates files combining original name plus description
' If there is no description the file is copied anyway
'
' Before running, check file paths in File Configuration Directories
' and create NewPath$ folders in Parameters, Designs, Spectra paths
'
Option Explicit
DefInt i-N
Const NewPath$ = "\Renamed"    ' change as required

Sub Main
    Dim i, ext$, f$, file$, fname$, path$, d50 As String*50, desc$
    On Error GoTo ExitMain
    Dim TypDesc(8) As String, nTyp
    TypDesc(0) = "Spectra (.csv)"
	TypDesc(1) = "Spectra (.dx)"
	TypDesc(2) = "Graph Axes"
	TypDesc(3) = "Film Indices"
	TypDesc(4) = "Film Designs"
	TypDesc(5) = "Opti Targets"
	TypDesc(6) = "Opti Variables"
    TypDesc(7) = "FILM File"
    TypDesc(8) = "FILM Archive"
    Begin Dialog UserDialog 360,154,"Select Data Type" ' %GRID:10,7,1,1
        ListBox 40,21,190,112,TypDesc(),.lstTyp
        OKButton 260,28,80,21
        CancelButton 260,63,80,21
    End Dialog
    Dim dlg As UserDialog
    Dialog dlg
    Busy True
    Select Case dlg.lstTyp
	Case 0
        nTyp = 1
        ext$ = ".csv"
    Case 1
        nTyp = 1
        ext$ = ".dx"
    Case Else
        nTyp = dlg.lstTyp
        Select Case nTyp
        Case 2
            ext$ = ".axw"
        Case 3
            ext$ = ".inw"
        Case 4
            ext$ = ".dew"
        Case 5
            ext$ = ".trw"
        Case 6
            ext$ = ".vaw"
        Case 7
            ext$ = ".flw"
        Case 8
            ext$ = ".faw"
        End Select
    End Select
    fname$ = Dir$(FilePath(nTyp) & "\*" & ext$)
    While fname$ <> ""
        file$ = LCase$(FilePath(nTyp) & "\" & fname$)
        Select Case nTyp
        Case 1, 2, 7    ' ASCII files
            Open file$ For Input As #1
            Line Input #1, desc$
            If ext$ = ".dx" Then
                desc$ = Filter$(Trim$(Mid$(desc$,9)))
            Else
                desc$ = Filter$(desc$)
            End If
        Case Else       ' binary files
            Open file$ For Binary Access Read As #1
            StringGet d50$
            desc$ = Filter$(d50$)
        End Select
        Close #1
        f$ = LCase$(FilePath(nTyp) & NewPath$ & "\" & Left$(fname$, Len(fname$)-Len(ext$)))
        If desc$ <> "" Then
            FileCopy file$, f$ & " (" & desc$ & ")" & ext$
        Else
            FileCopy file$, f$ & ext$
        End If
        fname$ = Dir$()
    Wend
    Busy False
    End
ExitMain:
    Busy False
    Select Case Err.Number
    Case 10107&
        MsgBox "Could not save in " & LCase$(FilePath(nTyp)) & "\renamed", vbCritical, "File Error"
    Case 10031& ' Cancel
    Case Else
        MsgBox Err.Description, vbCritical, "File Error"
    End Select
    End
End Sub

Sub StringGet(s$)
    Dim k&
    k& = Len(s$)
    If k = 0 Then
        s$ = ""
    Else
        ReDim a(k) As Byte
        Get #1, , a()
        s$ = StrConv(a(), vbUnicode)
    End If
End Sub

Function Filter$(ByVal d$) ' filter invalid file characters from description
    Dim i
    d$ = Replace$(Trim$(d$), Chr$(34), "") ' replace quote marks with ""
    For i=1 To Len(d$)
        Select Case Mid$(d$, i, 1)
        Case "\", "/", ":", "?", "|" ,"<", ">", "*"
            Mid$(d$, i, 1) = " "  ' replace bad chars with " "
        End Select
    Next i
    Filter$ = d$
End Function
