' FNum32.bas for FilmStar DESIGN 32 bit
' Copyright 1995-1998 FTG Software Associates
' 11/24/00...Replace k=macro() functions with BASIC equivalents
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Use with FILM Archive FNUM.
' This program simulates the performance of a filter in a convergent
' light beam with uniform illumination and given f-number. It does this
' by repeating the calculation over an angle range and averaging.
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   F Number
'   Command       basrun c:\winfilm\basic\f number.bas;
'
DefInt I-N
DefSng A-H, O-Z
Public Fnum, nRes

'  FilmStar DESIGN Key Words
'
'   Angle.......Angle of incidence in degrees
'   Angle = 5.23
'
'   Pol.........Polarization P, S, R
'   Pol = "R"
'
'   Macro.......Call DESIGN macro function (see DDE help)
'   kErr = Macro("Calcplot;")
'
Sub GetAngle  ' dialog box for entering f number and resolution
    On Error GoTo Quit   ' cancel button causes error
    ' Highlight the lines Begin Dialog...End Dialog and activate the
    ' built-in dialog editor. The dialog box will appear in the editor.
    Begin Dialog UserDialog 372, 94, "Enter values"
        Text 27, 23, 73, 13, "&F Number"
        Text 20, 58, 81, 13, "&Resolution"
        TextBox 105, 20, 80, 18, .FnumText
        TextBox 105, 55, 80, 18, .ResText
        OKButton 250, 19, 88, 21
        CancelButton 250, 54, 88, 21
    End Dialog
    Dim dlg As UserDialog
    If Fnum = 0 Then Fnum = 1.4
    If nRes = 0 Then nRes = 10
    dlg.FnumText=CStr(Fnum)
    dlg.ResText=CStr(nRes)
C1:
    Dialog dlg
    Fnum=Val(dlg.FnumText)
    If Fnum < .5 Then
        Beep
        MsgBox "Must be > 0.5", 48, "FNUM.BAS"
        GoTo C1
    End If
    nRes=Val(dlg.ResText)
    If nRes < 1 Then
        Beep
        MsgBox "Must be > 0", 48, "FNUM.BAS"
        GoTo C1
    End If
    Exit Sub
Quit:
    End
End Sub

Sub Main
    On Error GoTo MainEnd
    Do
        GetAngle
        Evaluate
    Loop
MainEnd:
    End
End Sub

Sub Evaluate   ' Does the calculation
    Dim xdata(), ydata(), ytmp(), yd()
    AxesDraw
    CalcPlotStart
    LineColor "B"
    a=1/(2*Fnum)
    rMax = Tan(Atn(a/Sqr(1-a^2)))   ' asin(a)
    delR = rMax/nRes
    Pol = "R"  ' random polarization
    For n = 1 To nRes
        StatusLabel "Iteration " & CStr(n)
        Angle = 57.29578 * Atn(Sqr(((delR*n)^2 + (delR*(n-1))^2)/2))
        wJ = ((delR*n)^2 - (delR*(n-1))^2)/rMax^2  ' uniform illumination
        wTot = wTot + wJ
        CalcPlot
        ydata = Spectrum_Y ' Get spectrum
        nData = UBound(ydata, 1)
        If n = 1 Then ReDim yd(1 To ndata, 2)
        For j = 1 To nData
            yd(j, 1) = yd(j, 1) + wJ * ydata(j, 1)
            yd(j, 2) = yd(j, 2) + wJ * ydata(j, 2)
        Next j
    Next n
    For j = 1 To nData
        ydata(j, 1) = yd(j, 1) / wTot   ' Reflectance
        ydata(j, 2) = yd(j, 2) / wTot   ' Transmittance
    Next j
    Spectrum_Y = ydata  ' Let spectrum
    LineColor "R"
    Replot
    CalcPlotDone
End Sub
