' LayerErrPlot.bas for FilmStar DESIGN
' Copyright 2012 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************

' Calculate design with layer or tooling factor errors

Option Explicit
Dim Matl$, Layer%
Const MinErr% = -15  ' Change values as required
Const MaxErr% = 15
Const DelErr% = 5

Sub Main
    Dim s$, t$, nkList$
    nkList$ = IndexList$()
    Const title$ = "Layer Error Plotter"
    Do
        s$ = InputBox ("Enter layer number (1-" & CStr(NumLayers) & ") or material symbol (" _
          & nkList$ & ")" & vbLf & vbLf & "Click Cancel to quit", title$, s$)
        If s$ = "" Then
            Exit Do
        ElseIf InStr(nkList$, UCase$(s$)) > 0 Then
            Matl$ = UCase$(s$)
            PlotCurves
        Else
            Matl$ = ""
            Layer = Val(s$)
            If Layer < 1 Or Layer > NumLayers Then
                MsgBox "Invalid layer or material - try again", vbExclamation, title$
            Else
                PlotCurves
            End If
        End If
    Loop Until s$ = ""
End Sub

Function IndexList$()
    Dim i%, s$, symb$(), ntyp$(), file$(), desc$()
    GetIndexList symb$(), ntyp$(), file$(), desc$()
    For i = 3 To UBound(symb$)
        s$ = s$ & symb$(i)
    Next i
    IndexList$ = s$
End Function

Sub PlotCurves
    Dim i%, j%, kPlot%, iErr%, qThick0!
    Dim nLayers%, Design0$, qThick!(), qDesc$(), qType$()
    PlotClose
    For i = 1 To 12
        PlotLegend(i) = ""
    Next i
    PlotLegendOn True
    If Matl$ = "" Then
        PlotTitle$= "Vary Layer " & CStr(Layer)
    Else
        PlotTitle$ = "Vary " & Matl$ & " Layers"
    End If
    PlotActivate
    If Matl$ = "" Then  ' varying single layer
        GetLayers nLayers, qThick(), qType$(), qDesc$()
        qThick0 = qThick(Layer)
        For iErr = MinErr To MaxErr Step DelErr
            qThick(Layer) = qThick0 * (1 + .01* iErr)
            SetLayers qThick(), qType$()
            kPlot = kPlot + 1
            If iErr = 0 Then
                PlotLegend(kPlot) = "Original"
            Else
                If iErr > 0 Then
                    PlotLegend(kPlot) = "+" & CStr(iErr) & "%"
                Else
                    PlotLegend(kPlot) = CStr(iErr) & "%"
                End If
            End If
            Calculate
            PlotNext
        Next iErr
        qThick(Layer) = qThick0
        SetLayers qThick(), qType$()
    Else               ' varying material
        Design0$ = Design
        For iErr = MinErr To MaxErr Step DelErr
            GetLayers nLayers, qThick(), qType$(), qDesc$()
            For j = 1 To nLayers
                If UCase$(qType$(j)) = Matl$ Then qThick(j) = qThick(j) * (1 + .01 * iErr)
            Next j
            SetLayers qThick(), qType$()
            kPlot = kPlot + 1
            If iErr = 0 Then
                PlotLegend(kPlot) = "Original"
            Else
                If iErr > 0 Then
                    PlotLegend(kPlot) = "+" & CStr(iErr) & "%"
                Else
                    PlotLegend(kPlot) = CStr(iErr) & "%"
                End If
            End If
            Calculate
            PlotNext
            Design = Design0$   ' restore original design
        Next iErr
    End If
End Sub
