Attribute VB_Name = "ModuleFMCheck"
' Use with FilmStar/Scantraq *.bas programs to determine whether Excel is running
' FTG Software 11.23.09

Private Type PROC32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * 260
End Type

Private Declare Function CreateToolhelp32Snapshot& Lib "kernel32" (ByVal lFlags&, ByVal ID&)
Private Declare Function Process32First& Lib "kernel32" (ByVal hSnapshot&, uProcess As PROC32)
Private Declare Function Process32Next& Lib "kernel32" (ByVal hSnapshot&, uProcess As PROC32)
Private Declare Sub CloseHandle Lib "kernel32" (ByVal hPass As Long)

Public Function XLCheck() As Boolean
    Dim i%, a() As Variant
    a = GetProcessesInfo()
    For i = 0 To UBound(a, 2)
        If InStr(UCase$(a(1, i)), "EXCEL.EXE") > 0 Then
            XLCheck = True
            Exit Function
        End If
    Next i
    XLCheck = False
End Function

Private Function GetProcessesInfo() As Variant()
    ' Thanks to Francesco Balena http://www.devx.com/vb2themax/Tip/19242
    Dim hSnapshot As Long
    Dim procEntry As PROC32
    Dim res As Long
    Dim index As Integer
    Dim arr() As Variant
    ' take a snapshot of all active processes
    hSnapshot = CreateToolhelp32Snapshot(2, 0)
    ' raise error if fails (for example under WinNT)
    If hSnapshot = -1 Then Err.Raise 999, , "Unable to get process snapshot"
    ' prepare the receiving buffer
    procEntry.dwSize = Len(procEntry)
    ' prepare a result array
    ReDim arr(5, 100) As Variant
    ' start with the first process
    res = Process32First(hSnapshot, procEntry)
    Do While res
        If index > UBound(arr) Then
            ReDim Preserve arr(5, index + 99) As Variant
        End If
        ' store information in array
        arr(0, index) = procEntry.th32ProcessID
        arr(1, index) = Left$(procEntry.szExeFile, InStr(procEntry.szExeFile & _
            vbNullChar, vbNullChar) - 1)
        arr(2, index) = procEntry.cntThreads
        arr(3, index) = procEntry.th32ParentProcessID
        ' get info on next process in the snapshot
        res = Process32Next(hSnapshot, procEntry)
        index = index + 1
    Loop
    ' close the snapshot
    CloseHandle hSnapshot
    ' return the result
    ReDim Preserve arr(5, index - 1) As Variant
    GetProcessesInfo = arr()
End Function
