' MonitorWidthTest.bas for FilmStar DESIGN
' Copyright 2012 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' Adds monochromator bandwidth to R/T vs thickness (monitor) calculations
' compares low and high resolution with monochromatic trace
'
' To run this program as a macro, insert the following under Evaluate...Macro...Edit
' (adjusting if your winfilm directory is different)
'
'   Description   Mon BW Development
'   Command       basrun c:\winfilm\basic32\MonitorWidthTest.bas;

Public wh!
Option Explicit

Sub Main
    On Error Resume Next    ' in case Cancel pushed
    wh = Val(IniString("Monochromator", "Bandwidth"))
    If wh = 0 Then wh = 5
    wh = Val(InputBox("50% bandwidth in nm?", "Monochromator Simulation", CStr(wh)))
    If wh > 0 Then
        Test   ' low + high + monochromatic
        WriteIniString "Monochromator", "Bandwidth", CStr(wh)
    End If
End Sub

Sub Test
    Dim i, w!, z!, s$
    GraphStart
    w! = EvalWave
	For z = w - wh To w + wh Step wh/2
		EvalWave = z
		Calculate
		PlotNext
	Next z
    s$ = "B=(.0625*B + .5*C + D + .5*E + .0625*F)/2.125;"
    For i = 70 To 67 Step -1
		s$ = s$ & "del " & Chr$(i) & ";"
    Next i
    PlotRun s$
	For z = w - 1.5*wh To w + 1.5*wh Step wh/4
		EvalWave = z
		Calculate
		PlotNext
	Next z
    s$ = "C=(.002*(C+O) + .0131*(D+N) + .0625*(E+M) + .2102*(F+L) + .5*(G+K) + .8409*(H+J) + I)/4.2574;"
	For i = 79 To 68 Step -1
		s$ = s$ & "del " & Chr$(i) & ";"
	Next i
    PlotRun s$
	EvalWave = w
    Calculate
    PlotLegendOn True
    PlotNext
End Sub

Sub GraphStart
    PlotClose
    PlotLegend(1) = "Low Resolution"
    PlotLegend(2) = "High Resolution"
    PlotLegend(3) = "Monochromatic"
    PlotLegendOn False
    PlotTitle = "Bandwidth = " & CStr(wh) & " nm"
    PlotActivate
End Sub
