' PE-SP1.bas for FilmStar DESIGN/MEASURE 32-bit
' Copyright 2001-2005 FTG Software Associates
' 12/08/05...Modified for asc extension now being used
'            by PE UvWinLab
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program converts PE UVWinLab .sp ASCII spectra to FilmStar
' DESIGN/MEASURE .csv format. It stores the new file in the default
' Spectra directory (File...Configuration...Directories). It is similar
' to PE-SP2.bas which loads the spectrum into FilmStar.
'
' To exit the program, click Cancel in the file name dialog
'
DefInt i-N
DefSng A-H, O-Z
Option Explicit
Option Base 1
' ********** Adjust as required **********
'Const ext$ = "sp"      ' old UvWinLab
Const ext$ = "asc"      ' new UvWinLab
' ****************************************
Dim sType$, dName$, fName$, file$, path$

Sub Main
    If InStr(UCase$(PgmExe), "DES") > 0 Then ' DESIGN                
        path$ = IniString("Files", "Path4")
    Else
        path$ = IniString("Files", "Path2")
    End If  
    If Right$(path$, 1) <> "\" Then path$ = path$ & "\"         
    dName$ = IniString("UVWinLab", "SpcPath")
    Do
        OpenFile
    Loop
End Sub

Sub OpenFile
    Dim i
    file$ = GetFilePath$(, ext$, dName$, "Open PE spectrum", 0)
    If file$ = "" Then
        WriteIniString "UVWinLab", "SpcPath", dName$
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - Len(ext$) - 1) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    Dim i, nData, xData(), yData(), desc$, dum$, s$
    If fName$ = "" Then Exit Sub
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Open file$ For Input As #1
    For i = 1 To 7
        Line Input #1, s$
    Next i
    Line Input #1, desc$    ' description
    Begin Dialog UserDialog 455,108,"Select Data Type"
        OptionGroup .optType
            OptionButton 35,22,120,14,"&Reflectance"
            OptionButton 170,22,120,15,"&Transmittance"
        OKButton 330,21,90,28
        Text 38,57,240,14,"&Description (optional, 50 char max)",.lbl1
        TextBox 36,72,275,20,.txtDesc
    End Dialog
    Dim dlg As UserDialog
    dlg.txtDesc = desc$
    If sType$ = "T" Then dlg.optType = 1
    Dialog dlg
    If dlg.optType = 0 Then sType$ = "R" Else sType$ = "T"
    desc = dlg.txtDesc
    If Len(desc$) > 50 Then desc$ = Left$(desc$,50)
    Do
        Line Input #1, s$
    Loop Until s$ = "#GR"
    For i = 1 To 7      ' skip 6 lines (using line 7)
        Line Input #1, s$
    Next i
    nData = Val(s$)     ' number of points
    Do
        Line Input #1, s$
    Loop Until s$ = "#DATA"
    ReDim xData(nData), yData(nData)
    For i = 1 To nData
        Line Input #1, s$
        Parse s$, dum$, xData(nData - i + 1), vbTab
        yData(nData - i + 1) = .01 * Val(s$)
    Next i
    Close #1
    ' The following line stores in FilmStar Spectra directory
    Open path$ & fName$ & ".csv" For Output As # 1
    Write #1, desc$
    Write #1, nData
    For i = 1 To nData
        If sType$ = "R" Then
            Write #1, xData(i), yData(i), 0
        Else
            Write #1, xData(i), 0, yData(i)
        End If
    Next i
    Close #1
    StatusLabel ""
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub

