' PE_UVWinCSV.bas for FilmStar DESIGN/MEASURE
' Copyright 2021 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program loads PE UVWinlab .csv spectra into FilmStar.
' Modify if file format not same as this sample:
'
'    Created As New Dataset,
'    nm,%R
'    2000.0,4.16
'    1999.0,4.19
'    1998.0,4.18
'    ...
'    350.0,4.24

Option Explicit
Option Base 1
DefInt I-N
DefSng A-H, O-Z
Dim sType$, dName$, fName$, file$

Const DataDrive$ = "C:\"
Const title$ = "UVWinlab CSV Import"

Sub Main
    dName$ = IniString("PE_UVCSV", "SpcPath")
    FilePath(1) = DataDrive$
    OpenFile
    WriteIniString "PE_UVCSV", "SpcPath", dName$
End Sub

Sub OpenFile
    Dim i
    file$ = GetFilePath$(, "csv", dName$, "Open PE UVWinlab spectrum", 0)
    If file$ = "" Then
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - 4) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    Dim i, j, k, spec, v, wave, desc$, dum$, s$
    Dim wUnit$, typ$, xDat(), yDat(), vAdj, isMeas As Boolean
    If fName$ = "" Then Exit Sub
    StatusLabel "Importing " & fName & " - please wait"
    Open file$ For Input As #1
    Line Input #1, desc$
    Line Input #1, s$   ' Read second line
    wUnit$ = Split(s$, ",")(0): typ$ = Split(s$, ",")(1)
    Select Case wUnit$
    Case "nm"
    Case Else
        MsgBox "Modification required for wavelength in " & wUnit$, vbCritical, title$
        End
    End Select

    Select Case typ$
    Case "%R"
        sType$ = "R": vAdj = 0.01
    Case "%T"
        sType$ = "T": vAdj = 0.01
    Case Else
        MsgBox "Modification required for " & typ$ & " units", vbCritical, title$
        End
    End Select
    Do While Not EOF(1)
        Line Input #1, s$
        If Trim$(s$) = "" Then Exit Do  ' Blank line is end of data
        k = k + 1
    Loop
    isMeas = (UCase$(Left$(PgmExe$, 1)) = "M")
    If isMeas Then
        ReDim xDat(k), yDat(k)
    Else
        ReDim xDat(k), yDat(k, 2)
    End If
    Close #1
    Open file$ For Input As #1  ' Reopen
    Line Input #1, dum$     ' Skip first two lines
    Line Input #1, dum$
    For i = 1 To k          ' Read spectrum lines
        j = k - i + 1
        Line Input #1, s$
        xDat(j) = Val(Split(s$, ",")(0))
        v = vAdj * Val(Split(s$, ",")(1))
        Select Case typ$
        Case "%R"
            If isMeas Then yDat(j) = v Else yDat(j, 1) = v
        Case "%T"
            If isMeas Then yDat(j) = v Else yDat(j, 2) = v
        End Select
    Next i
    Spectrum_X = xDat
    Spectrum_Y = yDat
    AxesDraw
    Replot
End Sub

