' SetPathMulti.bas for FilmStar DESIGN
' Copyright 2004-2013 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program creates a new ..\Winfilm\NameIt directory
' with multiple subdirectories
'
'    ..\Winfilm\NameIt\Data     ' Paremeters
'    ..\Winfilm\NameIt\Designs  ' Designs
'    ..\Winfilm\NameIt\Index    ' n,k Tables OPTIONAL
'    ..\Winfilm\NameIt\Spectra  ' Spectra
'
' Use this program if you want designs in one directory
' and component files in separate subdirectories
'
' Program IniPath.bas restores directories to default values
' BEFORE EXITING DESIGN. Another option for restoring directories
' is DefPath.bas.
'
Option Explicit
DefInt I-N

Sub Main
    Dim path$, kBrowse As Boolean
    path$ = InputBox("Enter " & PgmPath$ & " subdirectory or '?' to browse", "Set Directory", "")
    If InStr(path$, "?") > 0 Then
        On Error Resume Next
        Dim ShellApp As Object
        Set ShellApp = CreateObject("Shell.Application").BrowseForFolder(0, "Choose " & PgmPath$ & " directory", 0, PgmPath$)
        If ShellApp Is Nothing Then
            End
        Else
            path$ = ShellApp.Self.Name
            Set ShellApp = Nothing
            If Len(path$) > 0 Then path$ = InputBox("Confirm subdirectory", "Set Path", path$)
            If Not DirExists(PgmPath$ & "\" & path$) Then
                MsgBox "Invalid subdirectory", vbCritical, "Set Directory"
                End
            End If
            kBrowse = True
        End If
    End If
    If Len(path$) > 0 Then
        path$ = PgmPath & "\" & path$
        If Not kBrowse And DirExists(path$) Then
            If MsgBox(path$ & " already exists; click OK to use it", vbOkCancel, "Set Path") = vbCancel Then
                End
            Else
                MakePaths path$
            End If
        Else
            MakePaths path$
        End If      
    End If
End Sub

Sub MakePaths(ByVal p$)
    Dim nk As Boolean, p1$, p2$, p3$, p4$
    On Error GoTo BadPath
    Select Case MsgBox("Keep current n,k Tables directory " & FilePath(9) & "?", vbYesNoCancel + vbDefaultButton2, "Set Path")
    Case vbNo
        nk = True
    Case vbCancel
        End
    End Select
    p1$ = p$ & "\Data"      ' Parameters
    p2$ = p$ & "\Designs"   ' Designs
    p3$ = p$ & "\Index"     ' n,k Tables
    p4$ = p$ & "\Spectra"   ' Spectra
    If Not DirExists(p$) Then
        MkDir p$
        MkDir p1$
        MkDir p2$
        If nk Then MkDir p3$
        MkDir p4$
    Else
        If Not DirExists(p1$) Then MkDir p1$
        If Not DirExists(p2$) Then MkDir p2$
        If nk And Not DirExists(p3$) Then MkDir p3$
        If Not DirExists(p4$) Then MkDir p4$
    End If
    If nk Then
        DefaultPath p1$, p2$, p3$, p4$  ' Parameters, Designs, nk Tables, Spectra
    Else
        DefaultPath p1$, p2$,, p4$      ' Parameters, Designs, , Spectra
    End If
    Exit Sub
BadPath:
    MsgBox "Could not create directory " & p$, vbCritical, "Set Path"
    End
End Sub

Function DirExists(ByVal dName$) As Boolean
    Dim sdum$
    On Error Resume Next
    If Right(dName, 1) <> "\" Then dName = dName & "\"
    sdum = Dir$(dName & "*.*", vbDirectory)
    DirExists = Len(sdum) > 0
End Function
