' SHMDZU1.BAS for FilmStar DESIGN, MEASURE
' Copyright 1997-2001 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program converts Shimadzu .asc spectral data files to FilmStar
' DESIGN/MEASURE .csv format. It stores the new file in the default
' Spectra directory (File...Configuration...Directories). It is similar
' to SHMDZU2.BAS which loads the spectrum into FilmStar.
'
' If you have difficulties, check that you Shimadzu file has
' the same format as sample file C97076.ASC.
'
' To exit the program, click Cancel in the file name dialog

DefInt I-N
DefSng A-H, O-Z
Dim sType$, dName$, fName$, file$, path$

Sub Main
    If Instr(Ucase$(PgmExe), "DES") > 0 Then  ' DESIGN
        path$ = IniString("Files", "Path4")
    Else
        path$ = IniString("Files", "Path2")
    End If  
    If Right$(path$, 1) <> "\" Then path$ = path$ & "\"         
    Do ' Continue until Cancel button clicked
        OpenFile
    Loop
End Sub

Sub OpenFile
    file$ = GetFilePath$(, "asc", dName$, "Open Shimadzu spectrum", 0)
    If file$ = "" Then
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - 4) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    If fName$ = "" Then Exit Sub
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Dim sf$()
    Begin Dialog UserDialog 455,108,"Select Data Type"
        OptionGroup .optType
            OptionButton 35,22,120,14,"&Reflectance"
            OptionButton 170,22,120,15,"&Transmittance"
        OKButton 330,21,90,28
        Text 38,57,240,14,"&Description (optional, 50 char max)",.lbl1
        TextBox 36,72,275,20,.txtDesc
    End Dialog
    Dim dlg As UserDialog
    If sType$ = "T" Then dlg.optType = 1
    Dialog dlg
    If dlg.optType = 0 Then sType$ = "R" Else sType$ = "T"
    desc$ = dlg.txtDesc
    If Len(desc$) > 50 Then desc$ = Left$(Desc$, 50)
    Open file$ For Input As #1
    Do  While Not EOF(1)
        Line Input #1, s$
        If InStr(s$, ",") = 0 Then Exit Do
        k = k + 1
    Loop
    Close #1
    ReDim sf$(1 To k)
    Open file$ For Input As #1
    For i = 1 To k
        Line Input #1, sf$(k - i + 1)
    Next i
    Close #1

    ' The following line stores in same directory as .asc file
    ' Open dName$ & "\" & fName$ & ".csv" For Output As # 1

    ' The following line stores in FilmStar Spectra directory
    Open path$ & fName$ & ".csv" For Output As # 1

    Write #1, desc$
    Write #1, k
    For i = 1 To k
        Parse sf$(i), dum$, wave, ","
        Parse sf$(i), dum$, spec, ","
        v = spec / 100
        If sType$ = "R" Then
            Write #1, wave, v, 0
        Else
            Write #1, wave, 0, v
        End If
    Next i
    Close #1
    StatusLabel ""
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub
