'Program SproCrystalReport for FilmStar DESIGN
'         Copyright FTG Software 2008
'  Exports thickness data to SYRUSpro LMR files
'       NOT FOR USE WITH OPTICAL MONITOR
'
Option Explicit
DefInt i-N
DefSng A-H, O-Z
Option Base 1
'
' *****************************************************
'       XML Schema LeyboldMonitoringReport.xsd
' *****************************************************
'                
'        CHANGE AS REQUIRED FOR YOUR COMPUTER
'
Const SproPath$ = "c:\Winfilm\Monitor\Leybold XML\"

'  After creating an LMR file, copy it to your SyrusPRO
'  computer for further processing with LayerCalc2Recipe
'
'  Support for using LayerCalc2Recipe will be provided
'  by Martin Quinke at Leybold Optics, Hanau:
'
'          martin.quinke@leyboldoptics.com
'
' *****************************************************
' Vers 1.00  03/17/08... Initial release
'
Const vers$ = "1.00"

Const title$ = "Leybold Monitor Report"
Const qt$ = Chr$(34)

Sub Main
    Dim fName$, d$, s$
    Dim i, nLay, q(), qTyp$(), qDesc$()
    On Error GoTo ErrMain
    If InStr(Design, "(",) > 0 Then
        MsgBox "Designs with parentheses not allowed", vbCritical, title$
        End
    Else
        DesignConvert 1, "N"            ' convert to nm
        GetLayers nLay, q(), qTyp$(), qDesc$()   ' get design
        If nLay = 0 Then
            MsgBox "No layers in design", vbCritical, title$
            End
        End If
    End If
    fName$ = SproPath$ & FileName$(8) & ".lmr"
    If FileExists(fName$) Then
        Select Case MsgBox("File " & FileName$(8) & ".lmr already exists; overwrite it?", _
                    vbYesNoCancel + vbDefaultButton2, title$)
        Case vbYes  ' delete file
            Kill fName$
        Case vbNo   ' assign new file name
            i = 1
            Do
                fName$ = SproPath$ & FileName$(8) & "_" & CStr(i) & ".lmr"
                i = i + 1
            Loop Until Not FileExists(fName$)
            MsgBox "File name changed to " & FileName$(8) & "_" & CStr(i) & ".lmr", vbInformation, title$
        Case vbCancel
            End
        End Select
    End If
    Open fName$ For Output As #1

    s$ = "<monitoringreport name= |" & FileName$(8) & "| program=|FilmStar DESIGN|" _
          & " version=|" & vers$ & "| date=|" & Now & "| uuid=|" & UUID$ & "|" _
          & " xmlns:xsi=|http://www.w3.org/2001/XMLSchema-instance| xsi:noNamespaceSchemaLocation=" _
          & "|LeyboldMonitoringReport.xsd|>"

    Print #1, Replace$(s$, "|", qt)
    ' Start of nonsense optical monitor data
    Print #1, "<dispersionsdata>" & Replace$("<dispersion name=|| material=|| type=|Layer|>", "|", qt)
    Print #1, Replace$("<range min=|0| max=|0|></range>", "|", qt) & "<complex_refractive_index_table>"
    Print #1, Replace$("<row wavelength=|0| n=|0| k=|0|></row>", "|", qt)
    Print #1, "</complex_refractive_index_table></dispersion></dispersionsdata><design>"
    Print #1, Replace$("<match_angle unit=|deg|>0.0</match_angle>", "|", qt$) &"</design><plant>"
    Print #1, Replace$("<measurement mode=|Reflectance_Single_Side|></measurement>", "|", qt) & "</plant>"
    ' End of nonsense optical monitor data

    Print #1, "<monitoringspreadsheet>"
    d$ = Replace$ (" optical_thickness=|0| refractive_index=|0| chip=|1|></layer>", "|", qt)
    For i = 1 To nLay
        Print #1, Replace$("<layer number=|" & CStr(i) & "| material=||" _
                  & " wavelength=|0| physical_thickness=|" _
                  & Replace(Format$(q(i), "0.000"), ",", ".") & "|" , "|", qt$) & d$
    Next i
    Print #1, "</monitoringspreadsheet></monitoringreport>"
    Close #1
    Exit Sub
ErrMain:
    Close
    MsgBox Err.Description, vbCritical, title$
End Sub

Function FileExists(ByVal f$) As Boolean
    On Error GoTo NoFile
    FileExists = FileLen(f$) > 0
    Exit Function
NoFile:
    FileExists = False
End Function
