' Woollam1 for FilmStar DESIGN, MEASURE
' Copyright 1999-2002 FTG Software Associates
'
' ****************************************************
'    Warning: Save modified program with new name!!!
' ****************************************************
'
' This program converts Woollam .dat spectra to FilmStar .csv
' format. It stores the new file in the default Spectra
' directory (File...Configuration...Directories). It is
' similar to Woollam2.bas which imports spectra.
'
' If you have difficulties, check that your Woollam file has
' the same format as sample file UvVisRefl.dat.

Option Explicit
DefInt i-N
DefSng A-H, O-Z
Dim sType$, dName$, fName$, file$

Sub Main
    dName$ = IniString("Woollam", "SpcPath")
    Do ' Continue until Cancel button clicked
        OpenFile
    Loop
End Sub

Sub OpenFile
    Dim i
    file$ = GetFilePath$(, "dat", dName$, "Open Woollam spectrum; click Cancel to quit", 0)
    If file$ = "" Then
        If dName$ <> "" Then WriteIniString "Woollam", "SpcPath", dName$
        End
    Else
        For i = Len(file$) To 1 Step -1
            If Mid$(file$, i, 1) = "\" Then
                dName$ = Left$(file$, i - 1)            ' directory
                fName$ = Right$(file$, Len(file$) - i)
                fName$ = Left$(fName$, Len(fName$) - 4) ' file name
                Exit For
            End If
        Next i
        ConvertFile
    End If
End Sub

Sub ConvertFile()
    Dim k, kHead, nData, Wave, v, vdum, desc$, dum$, s$, sType$
    If fName$ = "" Then Exit Sub
    StatusLabel "Converting " & fName & " - please wait"
    On Error Resume Next
    Open file$ For Input As #1
    Line Input #1, desc$
    If Len(desc$) > 50 Then desc$ = Left$(desc$,50)
    kHead = 1
    Do
    	kHead = kHead + 1
        Line Input #1, s$
        If s$ = "nm" Then
        	Exit Do  ' Blank line is end of data
        ElseIf kHead > 4 Then
            MsgBox "Data file not in nm", vbCritical, "Import Woollam"
			Close #1
			Exit Sub
        End If
    Loop
    nData = 0
	Do
		nData = nData + 1
		Line Input #1, s$
	Loop Until EOF(1)
	Close #1
    ReDim sf$(1 To nData)
    Open file$ For Input As #1
	For k = 1 To kHead
		Line Input #1, s$
	Next k
	For k = 1 To nData
		Line Input #1, sf$(k)
		If k = 1 Then		' get data type
            If Mid$(sf$(k), 2, 1) = "R" Then  ' data type?
                sType$ = "R"	' reflectance
            ElseIf Mid$(sf$(k), 2, 1) = "T" Then
                sType$ = "T"	' transmittance
            Else
                MsgBox "Unknown data type (must be R or T)", vbCritical, "Woollam File Open"
                Close #1
                End
            End If
		End If
    Next k
    Close #1
    ' The following stores spectrum in FilmStar Spectra directory
    Open FilePath(1) & "\" & fName$ & ".csv" For Output As # 1
    Write #1, desc$
    Write #1, nData
    For k = 1 To nData
        Parse sf$(k), dum$, vdum, vbTab
        Parse sf$(k), dum$, Wave, vbTab
        Parse sf$(k), dum$, vdum, vbTab ' angle
        Parse sf$(k), dum$, v, vbTab
        If sType$ = "R" Then
            Write #1, Wave, v, 0
        Else
            Write #1, Wave, 0, v
        End If
    Next k
    Close #1
    MsgBox FilePath$(1) & "\" & fName$ & ".csv saved", vbInformation, "Woollam Convert"
    Busy False
End Sub

Sub Parse (strin$, strout$, xout As Variant, delim$)
    Dim i
    strin$ = LTrim$((strin$))
    i = InStr(strin$, delim$)
    If i > 0 Then
        strout$ = LTrim$(Mid$(strin$, 1, i - 1))
        strin$ = Mid$(strin$, i + Len(delim$))
    Else
        strout$ = strin$
        strin$ = ""
    End If
    xout = Val(strout$)
End Sub
